"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PQueueEnqueuOptimized = void 0;
class PQueueEnqueuOptimized {
    constructor() {
        this.dummy = {
            val: "dummy",
            priority: Number.MAX_SAFE_INTEGER
        };
        this.tail = this.dummy;
    }
    enQueue(value, priority) {
        const item = {
            val: value,
            priority
        };
        this.tail.next = item;
        this.tail = item;
    }
    deQueue() {
        if (!this.dummy.next) {
            throw new Error("The list is empty");
        }
        let temp = this.dummy.next;
        let max = temp;
        let preMax = this.dummy;
        while (temp && temp.next) {
            if (temp.next.priority > max.priority) {
                max = temp.next;
                preMax = temp;
            }
            temp = temp.next;
        }
        preMax.next = max.next;
        return max.val;
    }
}
exports.PQueueEnqueuOptimized = PQueueEnqueuOptimized;
